// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Camera/CameraComponent.h"
#include "GameFramework/Actor.h"
#include "WaypointActor.generated.h"

UCLASS()
class ENDLESSVENDETTA_API AWaypointActor : public AActor
{
	GENERATED_BODY()

	UCameraComponent* PlayersCam;

	float ScalingMagnitude;

	float ScalingY_Intercept;

	UPROPERTY(EditDefaultsOnly, Category = "Waypoint Scaling")
	float MaxDist = 8000.f;

	UPROPERTY(EditDefaultsOnly, Category = "Waypoint Scaling")
	float ScaleAtMaxDist = 8.f;

	UPROPERTY(EditDefaultsOnly, Category = "Waypoint Scaling")
	float MinDist = 900.f;

	UPROPERTY(EditDefaultsOnly, Category = "Waypoint Scaling")
	float ScaleAtMinDist = 0.15;
	
protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

public:
	// Sets default values for this actor's properties
    AWaypointActor();
	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	UFUNCTION(BlueprintImplementableEvent)
	void SetupWaypoint(UTexture2D* Icon, const FString& Desc);

};
