// Fill out your copyright notice in the Description page of Project Settings.


#include "GadgetTutorialStation.h"

#include "Blueprint/UserWidget.h"

// Sets default values
AGadgetTutorialStation::AGadgetTutorialStation()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = true;

}

// Called when the game starts or when spawned
void AGadgetTutorialStation::BeginPlay()
{
	Super::BeginPlay();
	
}

// Called every frame
void AGadgetTutorialStation::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);

}

void AGadgetTutorialStation::Interact()
{
	// opens up pick gadget widget
	if (GadgetsArray.IsEmpty()) return;

	FInputModeUIOnly InputMode;
	APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();

	PickGadgetWidget = CreateWidget<UUserWidget>(GetWorld(), PickGadgetWidgetClass);
	PickGadgetWidget->AddToViewport(3);
	
	PlayerController->SetInputMode(InputMode);
	PlayerController->bShowMouseCursor = true;
	PlayerController->bEnableClickEvents = true;
	PlayerController->bEnableMouseOverEvents = true;
}

void AGadgetTutorialStation::InteractPrompt()
{
	
}

FGadgetInfo AGadgetTutorialStation::NextGadget()
{
	FGadgetInfo GadgetInfo;
	// Either wrap around to the beginning or increment gadget index
	GadgetIndex = GadgetIndex >= GadgetsArray.Num() - 1 ? 0 : GadgetIndex + 1;
	
	GadgetInfo.GadgetIcon = GadgetsArray[GadgetIndex]->GetDefaultObject<AGadgetBase>()->GetGadgetIcon();
	GadgetInfo.GadgetDesc = GadgetsArray[GadgetIndex]->GetDefaultObject<AGadgetBase>()->GetGadgetDesc();
	GadgetInfo.GadgetName = GadgetsArray[GadgetIndex]->GetDefaultObject<AGadgetBase>()->GetGadgetName();
	return GadgetInfo;
}

FGadgetInfo AGadgetTutorialStation::PreviousGadget()
{
	FGadgetInfo GadgetInfo;
	// Either wrap around to the end or decrement gadget index
	GadgetIndex = GadgetIndex <= 0 ? GadgetsArray.Num() - 1 : GadgetIndex - 1;
	
	GadgetInfo.GadgetIcon = GadgetsArray[GadgetIndex]->GetDefaultObject<AGadgetBase>()->GetGadgetIcon();
	GadgetInfo.GadgetDesc = GadgetsArray[GadgetIndex]->GetDefaultObject<AGadgetBase>()->GetGadgetDesc();
	GadgetInfo.GadgetName = GadgetsArray[GadgetIndex]->GetDefaultObject<AGadgetBase>()->GetGadgetName();
	return GadgetInfo;
}

void AGadgetTutorialStation::SelectGadget()
{
	// Give Player the gadget
	// Despawn current gadgetRange
	// Spawn in the correct gadget range for the gadget

	UE_LOG(LogTemp, Warning, TEXT("Gadget Selected: %s"), *GadgetsArray[GadgetIndex]->GetDefaultObject<AGadgetBase>()->GetGadgetName());
}

void AGadgetTutorialStation::CloseWidget()
{
	// close the widget
	if (IsValid(PickGadgetWidget)) PickGadgetWidget->RemoveFromParent();

	CollectGarbage(RF_PendingKill);

	FInputModeGameOnly InputMode;
	APlayerController* PlayerController = GetWorld()->GetFirstPlayerController();
	PlayerController->SetInputMode(InputMode);
	PlayerController->bShowMouseCursor = false;
	PlayerController->bEnableClickEvents = false;
	PlayerController->bEnableMouseOverEvents = false;
}



